from django.shortcuts import render
from django.views.generic import View
from django.http import JsonResponse, HttpResponse
from dashboard.plotterpitch_django import django_pass
import plotly.graph_objects as go
import plotly.offline as opy
import json
import os
import datetime


def fetch_data(ticker, param):
    # scode_arr = [name for name in os.listdir("/home/kraken/Stock/v04/Samples/") if os.path.isdir(name)]
    data, date = django_pass(ticker, param)
    index = date[0]
    # index = [i for i in range(len(data[1])+7)]
    fig  = go.Figure(go.Scatter(y=data[1], x=index, name="Real Price", mode='lines+markers'))
    fig.add_trace(go.Scatter(y=data[0], x=index[-14:], name="Prediction"))
    title_str = "Stock Prediction "+ticker
    future_day = str(datetime.datetime.strptime(index[-1], "%Y-%m-%d")+datetime.timedelta(days=5))
    fig.update_layout(title={'text':title_str, 'xanchor':'center', 'x':0.5}, margin=dict(l=50, r=50, b=100, t=100, pad=1), paper_bgcolor='rgba(0,0,0,0)', plot_bgcolor='rgba(0,0,0,0)', xaxis=dict(range=[index[-120], future_day], type='date'))
    plot_div = opy.plot(fig, output_type='div')

    return plot_div

def main_render(request):
    scode_arr = [x for x in os.listdir("/home/kraken/Stock/v04/Samples/")]
    graph = fetch_data("AAPL", 200)
    scode_ready = [x for x in os.listdir("/home/kraken/Stock/v04/Samples/AAPL")]
    return render(request, 'index.html', {'graph':graph, 'scode_arr':scode_arr, 'scode_ready':scode_ready})

def get_train(request):
    graph = fetch_data("AAPL", 200)
    return HttpResponse(graph)

def pivot_data(request):
    # dataset = Order.objects.all()
    data = django_pass2("AAPL", 100)
    # data    = serializers.serialize('json', dataset)
    return JsonResponse(data, safe=False)

def get_stock(request):
    scode_arr = [x for x in os.listdir("/home/kraken/Stock/v04/Samples/")]
    if request.method == 'GET':
        form_val = request.GET['ticker']
        # form_param = request.POST['param']
        form_param = "1000"
        graph = fetch_data(form_val, int(form_param))
        scode_ready = [x for x in os.listdir("/home/kraken/Stock/v04/Samples/"+form_val)]
    else:
        graph = fetch_data("AAPL", 200)
        scode_ready = [x for x in os.listdir("/home/kraken/Stock/v04/Samples/AAPL")]
    return HttpResponse(graph)
    # return render(request, 'dynamic_chart.html', {'graph':graph, 'scode_arr':scode_arr, 'scode_ready':scode_ready})
    # return HttpResponse(graph)
